window.Gleam.initSearch([{"doc":"falcon","title":"falcon","content":"# falcon\n\n[![Package Version](https://img.shields.io/hexpm/v/falcon)](https://hex.pm/packages/falcon)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/falcon/)\n\n&gt; ⚠️ WARNING: This package has not been thoroughly tested yet, please report any bugs you run into. I will work on adding tests in the future but the version you are currently looking at with this warning was made in constrained time to use in a project\n\n## Installation\n\nThis package can be added to your Gleam project:\n\n```sh\ngleam add falcon\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/falcon&gt;.\n\n## Usage\n\n&gt; This package has not been documented, have a look in the [test](./test/) folder for more examples.\n\n```gleam\nimport falcon.{type FalconResponse}\nimport falcon/core.{Json, Url}\nimport gleam/dynamic\nimport gleam/io\nimport gleeunit/should\n\npub type PartialProduct {\n  PartialProduct(id: Int, title: String)\n}\n\npub fn main() {\n  let decoder =\n    dynamic.decode2(\n      PartialProduct,\n      dynamic.field(&quot;id&quot;, dynamic.int),\n      dynamic.field(&quot;title&quot;, dynamic.string),\n    )\n\n  let client =\n    falcon.new(\n      base_url: Url(&quot;https://dummyjson.com/&quot;),\n      headers: [],\n      timeout: falcon.default_timeout,\n    )\n\n  client\n  |&gt; falcon.get(&quot;/products/1&quot;, expecting: Json(decoder), options: [])\n  |&gt; should.be_ok\n  |&gt; fn(res: FalconResponse(PartialProduct)) { res.body }\n  |&gt; io.debug\n}\n\n\n// Output: PartialProduct(1, &quot;iPhone 9&quot;)\n```\n\n## Why should I use this?\n\nYou don&#39;t need to, [Hackney](https://github.com/gleam-lang/hackney) is probably enough for whatever you are doing but if you need a bit more configuration options or an axios-like interface, this is for you.\n\n&gt; NOTE: part of the hackney bindings were taken from the official Gleam hackney bindings and modified\n","url":"index.html"},{"doc":"falcon/hackney","title":"CrlCacheOptions","content":"pub type CrlCacheOptions {\n  SslCrlCache(SslCrlCacheOptions)\n}\n\nSslCrlCache(SslCrlCacheOptions)\n\n\nSynonyms:\nfalcon/hackney.CrlCacheOptions\nfalcon/hackney CrlCacheOptions","url":"falcon/hackney.html#CrlCacheOptions"},{"doc":"falcon/hackney","title":"CrlCheckMode","content":"pub type CrlCheckMode {\n  Peer\n}\n\nPeer\n\n\nSynonyms:\nfalcon/hackney.CrlCheckMode\nfalcon/hackney CrlCheckMode","url":"falcon/hackney.html#CrlCheckMode"},{"doc":"falcon/hackney","title":"Error","content":"pub type Error {\n  InvalidUtf8Response\n  Other(Dynamic)\n}\n\nInvalidUtf8Response\n\n\nOther(Dynamic)\n\n\nSynonyms:\nfalcon/hackney.Error\nfalcon/hackney Error","url":"falcon/hackney.html#Error"},{"doc":"falcon/hackney","title":"HackneyOption","content":"pub type HackneyOption {\n  Async\n  FollowRedirect(Bool)\n  MaxConnections(Int)\n  MaxRedirect(Int)\n  SSLOptions(List(SSLOption))\n  Timeout(Int)\n  WithBody(Bool)\n}\n\nAsync\n You probably DO NOT want to use this option. It is only here for compatibility\n\nFollowRedirect(Bool)\n\n\nMaxConnections(Int)\n\n\nMaxRedirect(Int)\n\n\nSSLOptions(List(SSLOption))\n\n\nTimeout(Int)\n\n\nWithBody(Bool)\n\n\nSynonyms:\nfalcon/hackney.HackneyOption\nfalcon/hackney HackneyOption","url":"falcon/hackney.html#HackneyOption"},{"doc":"falcon/hackney","title":"Options","content":"pub type Options =\n  List(HackneyOption)\n\n\nSynonyms:\nfalcon/hackney.Options\nfalcon/hackney Options","url":"falcon/hackney.html#Options"},{"doc":"falcon/hackney","title":"SSLOption","content":"pub type SSLOption {\n  Cacertfile(String)\n  CrlCheck(CrlCheckMode)\n  CrlCache(CrlCacheOptions)\n  Verify(SSLVerifyMode)\n  Versions(List(String))\n}\n\nCacertfile(String)\n\n\nCrlCheck(CrlCheckMode)\n\n\nCrlCache(CrlCacheOptions)\n\n\nVerify(SSLVerifyMode)\n\n\nVersions(List(String))\n\n\nSynonyms:\nfalcon/hackney.SSLOption\nfalcon/hackney SSLOption","url":"falcon/hackney.html#SSLOption"},{"doc":"falcon/hackney","title":"SSLVerifyMode","content":"pub type SSLVerifyMode {\n  VerifyNone\n  VerifyPeer\n  VerifyPeerStrict\n}\n\nVerifyNone\n\n\nVerifyPeer\n\n\nVerifyPeerStrict\n\n\nSynonyms:\nfalcon/hackney.SSLVerifyMode\nfalcon/hackney SSLVerifyMode","url":"falcon/hackney.html#SSLVerifyMode"},{"doc":"falcon/hackney","title":"SslCrlCacheOptions","content":"pub type SslCrlCacheOptions {\n  Internal(List(SslCrlInternalCacheOptions))\n}\n\nInternal(List(SslCrlInternalCacheOptions))\n\n\nSynonyms:\nfalcon/hackney.SslCrlCacheOptions\nfalcon/hackney SslCrlCacheOptions","url":"falcon/hackney.html#SslCrlCacheOptions"},{"doc":"falcon/hackney","title":"SslCrlInternalCacheOptions","content":"pub type SslCrlInternalCacheOptions {\n  Http(Int)\n}\n\nHttp(Int)\n\n\nSynonyms:\nfalcon/hackney.SslCrlInternalCacheOptions\nfalcon/hackney SslCrlInternalCacheOptions","url":"falcon/hackney.html#SslCrlInternalCacheOptions"},{"doc":"falcon/hackney","title":"send","content":"pub fn send(\n  request req: Request(String),\n  options options: List(HackneyOption),\n) -&gt; Result(Response(String), Error)\n\nSynonyms:\nfalcon/hackney.send\nfalcon/hackney send","url":"falcon/hackney.html#send"},{"doc":"falcon/hackney","title":"send_bits","content":"pub fn send_bits(\n  request: Request(BytesBuilder),\n  options: List(HackneyOption),\n) -&gt; Result(Response(BitArray), Error)\n\nSynonyms:\nfalcon/hackney.send_bits\nfalcon/hackney send_bits","url":"falcon/hackney.html#send_bits"},{"doc":"falcon/hackney","title":"falcon/hackney","content":"","url":"falcon/hackney.html"},{"doc":"falcon/core","title":"Config","content":"pub type Config {\n  Body(OpaqueBody)\n  Headers(Pairs)\n  Queries(Pairs)\n  ClientOptions(hackney.Options)\n}\n\nBody(OpaqueBody)\n A string to use as the body of the request - not meant to be used directly, use `post`, `put`, or `patch` instead, or if necessary, `to_body`\n\nHeaders(Pairs)\n A list of headers to *prepend* to the request\n\nQueries(Pairs)\n A list of query parameters to append to the URL\n\nClientOptions(hackney.Options)\n A list of options to pass to the underlying HTTP client to control things like timeouts and redirects\n\nSynonyms:\nfalcon/core.Config\nfalcon/core Config","url":"falcon/core.html#Config"},{"doc":"falcon/core","title":"FalconError","content":"pub type FalconError {\n  URLParseError\n  InvalidUtf8Response\n  HackneyError(Dynamic)\n  RawDecodingError(dynamic.DecodeErrors)\n  JsonDecodingError(json.DecodeError)\n}\n\nURLParseError\n\n\nInvalidUtf8Response\n\n\nHackneyError(Dynamic)\n\n\nRawDecodingError(dynamic.DecodeErrors)\n\n\nJsonDecodingError(json.DecodeError)\n\n\nSynonyms:\nfalcon/core.FalconError\nfalcon/core FalconError","url":"falcon/core.html#FalconError"},{"doc":"falcon/core","title":"FalconResponse","content":"pub type FalconResponse(a) {\n  FalconResponse(status: Int, headers: Pairs, body: a)\n}\n\nFalconResponse(status: Int, headers: Pairs, body: a)\n\n\nSynonyms:\nfalcon/core.FalconResponse\nfalcon/core FalconResponse","url":"falcon/core.html#FalconResponse"},{"doc":"falcon/core","title":"OpaqueBody","content":"pub opaque type OpaqueBody\n This exists to prevent the body from being added manually to requests like Get and Delete which don&#39;t support bodies.\n Since a user cannot create an OpaqueBody, they cannot add a body to a request that doesn&#39;t support it\n\nSynonyms:\nfalcon/core.OpaqueBody\nfalcon/core OpaqueBody","url":"falcon/core.html#OpaqueBody"},{"doc":"falcon/core","title":"Opts","content":"pub type Opts =\n  List(Config)\n\n\nSynonyms:\nfalcon/core.Opts\nfalcon/core Opts","url":"falcon/core.html#Opts"},{"doc":"falcon/core","title":"Pairs","content":"pub type Pairs =\n  List(#(String, String))\n\n\nSynonyms:\nfalcon/core.Pairs\nfalcon/core Pairs","url":"falcon/core.html#Pairs"},{"doc":"falcon/core","title":"ResultResponse","content":"pub type ResultResponse(a) =\n  Result(FalconResponse(a), FalconError)\n\n\nSynonyms:\nfalcon/core.ResultResponse\nfalcon/core ResultResponse","url":"falcon/core.html#ResultResponse"},{"doc":"falcon/core","title":"Target","content":"pub type Target(a) {\n  Json(Decoder(a))\n  Raw(Decoder(a))\n}\n\nJson(Decoder(a))\n\n\nRaw(Decoder(a))\n\n\nSynonyms:\nfalcon/core.Target\nfalcon/core Target","url":"falcon/core.html#Target"},{"doc":"falcon/core","title":"Url","content":"pub type Url {\n  Url(String)\n  SplitUrl(\n    scheme: Scheme,\n    host: String,\n    path: String,\n    port: Option(Int),\n  )\n}\n\nUrl(String)\n\n\nSplitUrl(\n  scheme: Scheme,\n  host: String,\n  path: String,\n  port: Option(Int),\n)\n\n\nSynonyms:\nfalcon/core.Url\nfalcon/core Url","url":"falcon/core.html#Url"},{"doc":"falcon/core","title":"append_path","content":"pub fn append_path(url: Url, path: String) -&gt; Url\n\nSynonyms:\nfalcon/core.append_path\nfalcon/core append_path","url":"falcon/core.html#append_path"},{"doc":"falcon/core","title":"delete","content":"pub fn delete(\n  to url: Url,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon/core.delete\nfalcon/core delete","url":"falcon/core.html#delete"},{"doc":"falcon/core","title":"error_to_string","content":"pub fn error_to_string(err: FalconError) -&gt; String\n Convert a FalconError to a string for display - some errors like HackneyError are not very helpful to the end user and are logged instead\nSynonyms:\nfalcon/core.error_to_string\nfalcon/core error_to_string","url":"falcon/core.html#error_to_string"},{"doc":"falcon/core","title":"extract_body","content":"pub fn extract_body(response: FalconResponse(a)) -&gt; a\n\nSynonyms:\nfalcon/core.extract_body\nfalcon/core extract_body","url":"falcon/core.html#extract_body"},{"doc":"falcon/core","title":"extract_headers","content":"pub fn extract_headers(\n  response: FalconResponse(a),\n) -&gt; List(#(String, String))\n\nSynonyms:\nfalcon/core.extract_headers\nfalcon/core extract_headers","url":"falcon/core.html#extract_headers"},{"doc":"falcon/core","title":"extract_params","content":"pub fn extract_params(\n  opts: List(Config),\n  state: #(Request(String), List(HackneyOption)),\n) -&gt; #(Request(String), List(HackneyOption))\n\nSynonyms:\nfalcon/core.extract_params\nfalcon/core extract_params","url":"falcon/core.html#extract_params"},{"doc":"falcon/core","title":"extract_status_code","content":"pub fn extract_status_code(response: FalconResponse(a)) -&gt; Int\n\nSynonyms:\nfalcon/core.extract_status_code\nfalcon/core extract_status_code","url":"falcon/core.html#extract_status_code"},{"doc":"falcon/core","title":"get","content":"pub fn get(\n  to url: Url,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon/core.get\nfalcon/core get","url":"falcon/core.html#get"},{"doc":"falcon/core","title":"patch","content":"pub fn patch(\n  to url: Url,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon/core.patch\nfalcon/core patch","url":"falcon/core.html#patch"},{"doc":"falcon/core","title":"post","content":"pub fn post(\n  to url: Url,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon/core.post\nfalcon/core post","url":"falcon/core.html#post"},{"doc":"falcon/core","title":"put","content":"pub fn put(\n  to url: Url,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon/core.put\nfalcon/core put","url":"falcon/core.html#put"},{"doc":"falcon/core","title":"send","content":"pub fn send(\n  method method: Method,\n  url url: Url,\n  expecting decode: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n Core function for sending requests, you would normally use the `get`, `post`, `put`, `patch`, or `delete` functions instead\nSynonyms:\nfalcon/core.send\nfalcon/core send","url":"falcon/core.html#send"},{"doc":"falcon/core","title":"to_body","content":"pub fn to_body(body: String) -&gt; Config\n Convert a string to an OpaqueBody - only use this if you are using the `send` function directly\nSynonyms:\nfalcon/core.to_body\nfalcon/core to_body","url":"falcon/core.html#to_body"},{"doc":"falcon/core","title":"url_to_string","content":"pub fn url_to_string(url: Url) -&gt; String\n\nSynonyms:\nfalcon/core.url_to_string\nfalcon/core url_to_string","url":"falcon/core.html#url_to_string"},{"doc":"falcon/core","title":"falcon/core","content":"","url":"falcon/core.html"},{"doc":"falcon","title":"Client","content":"pub opaque type Client\n\n\nSynonyms:\nfalcon.Client\nfalcon Client","url":"falcon.html#Client"},{"doc":"falcon","title":"FalconError","content":"pub type FalconError =\n  core.FalconError\n\n\nSynonyms:\nfalcon.FalconError\nfalcon FalconError","url":"falcon.html#FalconError"},{"doc":"falcon","title":"FalconResponse","content":"pub type FalconResponse(a) =\n  core.FalconResponse(a)\n\n\nSynonyms:\nfalcon.FalconResponse\nfalcon FalconResponse","url":"falcon.html#FalconResponse"},{"doc":"falcon","title":"ResultResponse","content":"pub type ResultResponse(a) =\n  core.ResultResponse(a)\n\n\nSynonyms:\nfalcon.ResultResponse\nfalcon ResultResponse","url":"falcon.html#ResultResponse"},{"doc":"falcon","title":"default_timeout","content":"pub const default_timeout: Option(Int) = Some(15_000)\n\nSynonyms:\nfalcon.default_timeout\nfalcon default_timeout","url":"falcon.html#default_timeout"},{"doc":"falcon","title":"delete","content":"pub fn delete(\n  client client: Client,\n  path path: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon.delete\nfalcon delete","url":"falcon.html#delete"},{"doc":"falcon","title":"extract_headers","content":"pub fn extract_headers(\n  opts: List(Config),\n) -&gt; List(#(String, String))\n\nSynonyms:\nfalcon.extract_headers\nfalcon extract_headers","url":"falcon.html#extract_headers"},{"doc":"falcon","title":"get","content":"pub fn get(\n  client client: Client,\n  path path: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon.get\nfalcon get","url":"falcon.html#get"},{"doc":"falcon","title":"merge_opts","content":"pub fn merge_opts(\n  client: Client,\n  opts: List(Config),\n) -&gt; List(Config)\n This is used internally to merge the client options with the request options, it is only exposed for testing purposes\nSynonyms:\nfalcon.merge_opts\nfalcon merge_opts","url":"falcon.html#merge_opts"},{"doc":"falcon","title":"new","content":"pub fn new(\n  base_url base_url: Url,\n  headers headers: List(#(String, String)),\n  timeout timeout: Option(Int),\n) -&gt; Client\n\nSynonyms:\nfalcon.new\nfalcon new","url":"falcon.html#new"},{"doc":"falcon","title":"patch","content":"pub fn patch(\n  client client: Client,\n  path path: String,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon.patch\nfalcon patch","url":"falcon.html#patch"},{"doc":"falcon","title":"post","content":"pub fn post(\n  client client: Client,\n  path path: String,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon.post\nfalcon post","url":"falcon.html#post"},{"doc":"falcon","title":"put","content":"pub fn put(\n  client client: Client,\n  path path: String,\n  body body: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n\nSynonyms:\nfalcon.put\nfalcon put","url":"falcon.html#put"},{"doc":"falcon","title":"send","content":"pub fn send(\n  client client: Client,\n  method method: Method,\n  path path: String,\n  expecting target: Target(a),\n  options opts: List(Config),\n) -&gt; Result(FalconResponse(a), FalconError)\n A way to send a request with a client, you would normally want to use the convenience functions (get, post, put, patch, delete) instead\nSynonyms:\nfalcon.send\nfalcon send","url":"falcon.html#send"},{"doc":"falcon","title":"falcon","content":"","url":"falcon.html"}]);